<html>
<head>
<title>OgreShaderScriptTranslator.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderScriptTranslator.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderScriptTranslator_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderScriptTranslator_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderScriptTranslator_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreScriptTranslator_8h.html">OgreScriptTranslator.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreScriptCompiler_8h.html">OgreScriptCompiler.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 <span class="keyword">namespace </span>RTShader {
<a name="l00036"></a>00036 
<a name="l00047"></a><a class="code" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html">00047</a> <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> <a class="code" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGScriptTranslator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ScriptTranslator.html" title="This class translates script AST (abstract syntax tree) into Ogre resources.">ScriptTranslator</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050     
<a name="l00051"></a>00051     <a class="code" href="classOgre_1_1RTShader_1_1SGScriptTranslator.html" title="This class responsible for translating core features of the RT Shader System for Ogre material script...">SGScriptTranslator</a>();
<a name="l00052"></a>00052 
<a name="l00056"></a>00056     <span class="keyword">virtual</span> <span class="keywordtype">void</span> translate(<a class="code" href="classOgre_1_1ScriptCompiler.html" title="This is the main class for the compiler.">ScriptCompiler</a> *compiler, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">AbstractNodePtr</a> &amp;node);
<a name="l00057"></a>00057 
<a name="l00061"></a>00061     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#a5f2c5e5767418e36bd32df673e59fa25" title="Converts the node to a boolean and returns true if successful.">ScriptTranslator::getBoolean</a>;
<a name="l00062"></a>00062     
<a name="l00066"></a>00066     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#ae287a72330c6b167880ec9d6b8b8b27f" title="Converts the node to a string and returns true if successful.">ScriptTranslator::getString</a>;
<a name="l00067"></a>00067     
<a name="l00071"></a>00071     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#a6895f912f2300d18805f83e6132e413f" title="Converts the node to a Real and returns true if successful.">ScriptTranslator::getReal</a>;
<a name="l00072"></a>00072     
<a name="l00076"></a>00076     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#a752b65312b7bac80467cdbd692f77ad2" title="Converts the node to a float and returns true if successful.">ScriptTranslator::getFloat</a>;
<a name="l00077"></a>00077 
<a name="l00081"></a>00081     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#aa138393408a4e3608133238e5de593f3" title="Converts the node to an integer and returns true if successful.">ScriptTranslator::getInt</a>; 
<a name="l00082"></a>00082 
<a name="l00086"></a>00086     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#a42289a7095cc090b5eb8796276ab85f1" title="Converts the node to an unsigned integer and returns true if successful.">ScriptTranslator::getUInt</a>; 
<a name="l00087"></a>00087 
<a name="l00091"></a>00091     <span class="keyword">using</span> <a class="code" href="classOgre_1_1ScriptTranslator.html#afb9903db920fbed2a27d86f664501c84" title="Converts the range of nodes to a ColourValue and returns true if successful.">ScriptTranslator::getColour</a>;
<a name="l00092"></a>00092     
<a name="l00104"></a>00104     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* getGeneratedSubRenderState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">protected</span>:
<a name="l00113"></a>00113     <span class="keywordtype">void</span> translatePass(<a class="code" href="classOgre_1_1ScriptCompiler.html" title="This is the main class for the compiler.">ScriptCompiler</a> *compiler, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">AbstractNodePtr</a> &amp;node);
<a name="l00114"></a>00114 
<a name="l00120"></a>00120     <span class="keywordtype">void</span> translateTextureUnit(<a class="code" href="classOgre_1_1ScriptCompiler.html" title="This is the main class for the compiler.">ScriptCompiler</a> *compiler, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">AbstractNodePtr</a> &amp;node);
<a name="l00121"></a>00121 
<a name="l00130"></a>00130     <span class="keywordtype">void</span> addSubRenderState(<a class="code" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a>* newSubRenderState, 
<a name="l00131"></a>00131         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; dstTechniqueSchemeName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName, 
<a name="l00132"></a>00132         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> passIndex);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134             
<a name="l00135"></a>00135 <span class="keyword">protected</span>:
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="group__RTShader.html#ga6b45a84c630ce4feb7d42cb6281547c7">00137</a>     <a class="code" href="classOgre_1_1RTShader_1_1RenderState.html" title="This is a container class for sub render state class.">RenderState</a>* <a class="code" href="group__RTShader.html#ga6b45a84c630ce4feb7d42cb6281547c7">mGeneratedRenderState</a>; <span class="comment">//Render state created as a result of the current node being parsed</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 };
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
